Livewire
--------

Realtime video streaming in 'Koala' format via TCP/IP to the C64

Koala image converter based on c64image.py by Philip Heron, but stripped unwanted stuff,
plus some optimizations.

Quirks: Socket is opened/closed for each video frame, keeping just one socket open results
in stutter and freezing after a while for reasons unknown.
Anyways, this was just for kicks :)

Hardware Prerequisites
-------------

1. A semi fast computer ("server")
2. A Commodore 64 
3. A 1541 Ultimate 2+ with Ethernet

Installation
------------

Instructions for MacOS 10.14 only, but should of course work for other platforms too.

Install runtime dependencies

    brew install ffmpeg
    brew install pypy3
    pip_pypy3 install pillow
   
    Optionally
    brew install youtube-dl

If pillow installation complains about missing zlib headers, try this:

    sudo installer -pkg /Library/Developer/CommandLineTools/Packages/macOS_SDK_headers_for_macOS_10.14.pkg -target /

Enable REU on the 1541U.
See to that it has an IP on the same network as the server. 
Run the client PRG on the C64 (pro tip: use sock.py provided by Gideon in the U1541 package to launch it)

Start streaming a video

    ./stream2c64 -c <C64 IP ADDRESS> somevideo.avi
   
Streaming the Mac's built-in webcam

    ./stream2c64 -c <C64 IP ADDRESS> --webcam

Or pipe a video stream ffmpeg handles

    youtube-dl -f --prefer-ffmpeg --no-color --no-cache-dir --no-progress -o - -f 22/18 https://www.youtube.com/watch\?v\=89wq5EoXy-0 | ./stream2c64 -c <C64 IP ADDRESS>

Good luck

PS! Press SPACE to skip the intro

